''this is a modified version of the viewr that simply draws all the possible
''color groups. each group contains 8 shades. it will draw all 16 groups one after
''the other, press a key to move to the next group.

CON
  _CLKMODE = xtal1 + pll16x          ''''''''''''''''''''''''''''''''''''''''''''
  _XINFREQ = 5_000_000               ''  This viewer is hardcoded to display   ''
                                     ''  video using demoboard/protoboard      ''
  HORIZONTAL_PIXELS = 160            ''  settings.   Keyboard on 26.           ''
  VERTICAL_PIXELS   = 96             ''  .ppm images must be on your SD.       ''
                                     ''                                        ''
   spiDO     = 0                    ''''''''''''''''''''''''''''''''''''''''''''
   spiClk    = 1
   spiDI     = 2
   spiCS     = 3

VAR
  byte          displayb[HORIZONTAL_PIXELS * VERTICAL_PIXELS]   'allocate display buffer in RAM
                                  
  long          index             'temp offset for byte statement below

  long          i, j, k, l, m     'misc working vars
        '' SD Vars

       
OBJ
     tv   : "potatohead--hi-color-raster-variable-resolution_01_TV"
     key  : "Combokeyboard"
     
PUB start | color_group, shade, o, d, p ,calc,counter,count,row,col,pos,r,b,g,crayon,lastchar,totalcol,press,center,char

    key.start(26)
    tv.start(@displayb)  'start the tv cog & pass it the address of the bitmap

  bytefill(@displayb,2,vertical_pixels*horizontal_pixels)

    repeat color_group from 0 to 15
      repeat i from 1 to 159
       repeat j from 1 to 95
         plot (i,j,(i/20)+color_group*8)
      k := key.newkey
                       
 reboot

pub plot(x,y,c)
  'very simple dot plotter
  'one byte per pixel is sweet!

  displayb[y*HORIZONTAL_PIXELS+x] := @@clut[c & %01111111]   '128 color CLUT
  

DAT

'shades
                 '  0- black
                 '       1- a bit less black
                 '            2- faded dark
'                                  3- faded medium
'                                       4- faded
'                                            5- pastel
'                                                 6- saturated bright
'                                                      7- saturated dark
clut
clut0   byte  byte  $02, $03, $04, $05, $06, $07, $07, $07  ' 0- grey
clut1   byte  byte  $19, $1a, $1b, $1c, $1d, $1e, $98, $af  ' 1- purple
clut2   byte  byte  $29, $2a, $2b, $2c, $2d, $2e, $a8, $bf  ' 2- reddish purple
clut3   byte  byte  $39, $3a, $3b, $3c, $3d, $3e, $b8, $cf  ' 3- red
clut4   byte  byte  $49, $4a, $4b, $4c, $4d, $4e, $c8, $df  ' 4- red/orange
clut5   byte  byte  $59, $5a, $5b, $5c, $5d, $5e, $d8, $ef  ' 5- orange/red
clut6   byte  byte  $69, $6a, $6b, $6c, $6d, $6e, $e8, $ff  ' 6- yellow/brown
clut7   byte  byte  $79, $7a, $7b, $7c, $7d, $7e, $f8, $0f  ' 7- yellowish green 
clut8   byte  byte  $89, $8a, $8b, $8c, $8d, $8e, $08, $1f  ' 8- yellow green green
clut9   byte  byte  $99, $9a, $9b, $9c, $9d, $9e, $18, $2f  ' 9- green
cluta   byte  byte  $a9, $aa, $ab, $ac, $ad, $ae, $28, $3f  '10- blue green
clutb   byte  byte  $b9, $ba, $bb, $bc, $bd, $be, $38, $4f  '11- teal
clutc   byte  byte  $c9, $ca, $cb, $cc, $cd, $ce, $48, $5f  '12- light blue
clutd   byte  byte  $d9, $da, $db, $dc, $dd, $de, $58, $6f  '13- blue
clute   byte  byte  $e9, $ea, $eb, $ec, $ed, $ee, $68, $7f  '14- purplish saturated blue
clutf   byte  byte  $f9, $fa, $fb, $fc, $fd, $fe, $78, $8f  '15- purplish blue

' color i want = (color group * 8 + shade)  